/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the OrganizationMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OrganizationMutable{}

// OrganizationMutable struct for OrganizationMutable
type OrganizationMutable struct {
	CustomerId string `json:"customer_id"`
	Name string `json:"name"`
	ContactInfo ContactInfo `json:"contact_info"`
	Active *bool `json:"active,omitempty"`
	// The map of any string values used for cutom external references. 
	ExternalReferences *map[string]string `json:"external_references,omitempty"`
	Timezone *string `json:"timezone,omitempty"`
	OfficeHours *OfficeHoursSettings `json:"office_hours,omitempty"`
	InfoMessagesActive *bool `json:"info_messages_active,omitempty"`
	DirectCalling *bool `json:"direct_calling,omitempty"`
	ActivityThreshold Threshold `json:"activity_threshold"`
	ExternalSystems []ExternalSystem `json:"external_systems,omitempty"`
	CooldownThreshold *Threshold `json:"cooldown_threshold,omitempty"`
	AutoresponderCooldown Threshold `json:"autoresponder_cooldown"`
	CouponProviders []CouponProvider `json:"coupon_providers,omitempty"`
	ExternalIntegrations *ExternalIntegrations `json:"external_integrations,omitempty"`
	LifecycleSettings *OrganizationMutableLifecycleSettings `json:"lifecycle_settings,omitempty"`
	ContactAttributes []ContactAttribute `json:"contact_attributes,omitempty"`
	// \"d\" -> \"2006-01-02\" \"u\" -> \"01/02/2006\" \"e\" -> \"02/01/2006\" \"x\" -> \"02.01.2006\"
	DateFormat *string `json:"date_format,omitempty"`
	StopKeywords []string `json:"stop_keywords"`
	LanguageSettings *OrganizationMutableLanguageSettings `json:"language_settings,omitempty"`
	Formality Formality `json:"formality"`
	ValidationCenterSettings *OrganizationMutableValidationCenterSettings `json:"validation_center_settings,omitempty"`
	PolyprintShopId *string `json:"polyprint_shop_id,omitempty"`
	PolyprintGroupId *string `json:"polyprint_group_id,omitempty"`
	PolyprintNfcProductId *string `json:"polyprint_nfc_product_id,omitempty"`
	DefaultWhatsappProvider *Provider `json:"default_whatsapp_provider,omitempty"`
	// Default billing account for newly created org. If none is selected, new will be auto-created.
	BillingAccountId *string `json:"billing_account_id,omitempty"`
}

// NewOrganizationMutable instantiates a new OrganizationMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrganizationMutable(customerId string, name string, contactInfo ContactInfo, activityThreshold Threshold, autoresponderCooldown Threshold, stopKeywords []string, formality Formality) *OrganizationMutable {
	this := OrganizationMutable{}
	this.CustomerId = customerId
	this.Name = name
	this.ContactInfo = contactInfo
	this.ActivityThreshold = activityThreshold
	this.AutoresponderCooldown = autoresponderCooldown
	this.StopKeywords = stopKeywords
	this.Formality = formality
	return &this
}

// NewOrganizationMutableWithDefaults instantiates a new OrganizationMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrganizationMutableWithDefaults() *OrganizationMutable {
	this := OrganizationMutable{}
	return &this
}

// GetCustomerId returns the CustomerId field value
func (o *OrganizationMutable) GetCustomerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetCustomerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CustomerId, true
}

// SetCustomerId sets field value
func (o *OrganizationMutable) SetCustomerId(v string) {
	o.CustomerId = v
}

// GetName returns the Name field value
func (o *OrganizationMutable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *OrganizationMutable) SetName(v string) {
	o.Name = v
}

// GetContactInfo returns the ContactInfo field value
func (o *OrganizationMutable) GetContactInfo() ContactInfo {
	if o == nil {
		var ret ContactInfo
		return ret
	}

	return o.ContactInfo
}

// GetContactInfoOk returns a tuple with the ContactInfo field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetContactInfoOk() (*ContactInfo, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactInfo, true
}

// SetContactInfo sets field value
func (o *OrganizationMutable) SetContactInfo(v ContactInfo) {
	o.ContactInfo = v
}

// GetActive returns the Active field value if set, zero value otherwise.
func (o *OrganizationMutable) GetActive() bool {
	if o == nil || IsNil(o.Active) {
		var ret bool
		return ret
	}
	return *o.Active
}

// GetActiveOk returns a tuple with the Active field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetActiveOk() (*bool, bool) {
	if o == nil || IsNil(o.Active) {
		return nil, false
	}
	return o.Active, true
}

// HasActive returns a boolean if a field has been set.
func (o *OrganizationMutable) HasActive() bool {
	if o != nil && !IsNil(o.Active) {
		return true
	}

	return false
}

// SetActive gets a reference to the given bool and assigns it to the Active field.
func (o *OrganizationMutable) SetActive(v bool) {
	o.Active = &v
}

// GetExternalReferences returns the ExternalReferences field value if set, zero value otherwise.
func (o *OrganizationMutable) GetExternalReferences() map[string]string {
	if o == nil || IsNil(o.ExternalReferences) {
		var ret map[string]string
		return ret
	}
	return *o.ExternalReferences
}

// GetExternalReferencesOk returns a tuple with the ExternalReferences field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetExternalReferencesOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.ExternalReferences) {
		return nil, false
	}
	return o.ExternalReferences, true
}

// HasExternalReferences returns a boolean if a field has been set.
func (o *OrganizationMutable) HasExternalReferences() bool {
	if o != nil && !IsNil(o.ExternalReferences) {
		return true
	}

	return false
}

// SetExternalReferences gets a reference to the given map[string]string and assigns it to the ExternalReferences field.
func (o *OrganizationMutable) SetExternalReferences(v map[string]string) {
	o.ExternalReferences = &v
}

// GetTimezone returns the Timezone field value if set, zero value otherwise.
func (o *OrganizationMutable) GetTimezone() string {
	if o == nil || IsNil(o.Timezone) {
		var ret string
		return ret
	}
	return *o.Timezone
}

// GetTimezoneOk returns a tuple with the Timezone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetTimezoneOk() (*string, bool) {
	if o == nil || IsNil(o.Timezone) {
		return nil, false
	}
	return o.Timezone, true
}

// HasTimezone returns a boolean if a field has been set.
func (o *OrganizationMutable) HasTimezone() bool {
	if o != nil && !IsNil(o.Timezone) {
		return true
	}

	return false
}

// SetTimezone gets a reference to the given string and assigns it to the Timezone field.
func (o *OrganizationMutable) SetTimezone(v string) {
	o.Timezone = &v
}

// GetOfficeHours returns the OfficeHours field value if set, zero value otherwise.
func (o *OrganizationMutable) GetOfficeHours() OfficeHoursSettings {
	if o == nil || IsNil(o.OfficeHours) {
		var ret OfficeHoursSettings
		return ret
	}
	return *o.OfficeHours
}

// GetOfficeHoursOk returns a tuple with the OfficeHours field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetOfficeHoursOk() (*OfficeHoursSettings, bool) {
	if o == nil || IsNil(o.OfficeHours) {
		return nil, false
	}
	return o.OfficeHours, true
}

// HasOfficeHours returns a boolean if a field has been set.
func (o *OrganizationMutable) HasOfficeHours() bool {
	if o != nil && !IsNil(o.OfficeHours) {
		return true
	}

	return false
}

// SetOfficeHours gets a reference to the given OfficeHoursSettings and assigns it to the OfficeHours field.
func (o *OrganizationMutable) SetOfficeHours(v OfficeHoursSettings) {
	o.OfficeHours = &v
}

// GetInfoMessagesActive returns the InfoMessagesActive field value if set, zero value otherwise.
func (o *OrganizationMutable) GetInfoMessagesActive() bool {
	if o == nil || IsNil(o.InfoMessagesActive) {
		var ret bool
		return ret
	}
	return *o.InfoMessagesActive
}

// GetInfoMessagesActiveOk returns a tuple with the InfoMessagesActive field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetInfoMessagesActiveOk() (*bool, bool) {
	if o == nil || IsNil(o.InfoMessagesActive) {
		return nil, false
	}
	return o.InfoMessagesActive, true
}

// HasInfoMessagesActive returns a boolean if a field has been set.
func (o *OrganizationMutable) HasInfoMessagesActive() bool {
	if o != nil && !IsNil(o.InfoMessagesActive) {
		return true
	}

	return false
}

// SetInfoMessagesActive gets a reference to the given bool and assigns it to the InfoMessagesActive field.
func (o *OrganizationMutable) SetInfoMessagesActive(v bool) {
	o.InfoMessagesActive = &v
}

// GetDirectCalling returns the DirectCalling field value if set, zero value otherwise.
func (o *OrganizationMutable) GetDirectCalling() bool {
	if o == nil || IsNil(o.DirectCalling) {
		var ret bool
		return ret
	}
	return *o.DirectCalling
}

// GetDirectCallingOk returns a tuple with the DirectCalling field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetDirectCallingOk() (*bool, bool) {
	if o == nil || IsNil(o.DirectCalling) {
		return nil, false
	}
	return o.DirectCalling, true
}

// HasDirectCalling returns a boolean if a field has been set.
func (o *OrganizationMutable) HasDirectCalling() bool {
	if o != nil && !IsNil(o.DirectCalling) {
		return true
	}

	return false
}

// SetDirectCalling gets a reference to the given bool and assigns it to the DirectCalling field.
func (o *OrganizationMutable) SetDirectCalling(v bool) {
	o.DirectCalling = &v
}

// GetActivityThreshold returns the ActivityThreshold field value
func (o *OrganizationMutable) GetActivityThreshold() Threshold {
	if o == nil {
		var ret Threshold
		return ret
	}

	return o.ActivityThreshold
}

// GetActivityThresholdOk returns a tuple with the ActivityThreshold field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetActivityThresholdOk() (*Threshold, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActivityThreshold, true
}

// SetActivityThreshold sets field value
func (o *OrganizationMutable) SetActivityThreshold(v Threshold) {
	o.ActivityThreshold = v
}

// GetExternalSystems returns the ExternalSystems field value if set, zero value otherwise.
func (o *OrganizationMutable) GetExternalSystems() []ExternalSystem {
	if o == nil || IsNil(o.ExternalSystems) {
		var ret []ExternalSystem
		return ret
	}
	return o.ExternalSystems
}

// GetExternalSystemsOk returns a tuple with the ExternalSystems field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetExternalSystemsOk() ([]ExternalSystem, bool) {
	if o == nil || IsNil(o.ExternalSystems) {
		return nil, false
	}
	return o.ExternalSystems, true
}

// HasExternalSystems returns a boolean if a field has been set.
func (o *OrganizationMutable) HasExternalSystems() bool {
	if o != nil && !IsNil(o.ExternalSystems) {
		return true
	}

	return false
}

// SetExternalSystems gets a reference to the given []ExternalSystem and assigns it to the ExternalSystems field.
func (o *OrganizationMutable) SetExternalSystems(v []ExternalSystem) {
	o.ExternalSystems = v
}

// GetCooldownThreshold returns the CooldownThreshold field value if set, zero value otherwise.
func (o *OrganizationMutable) GetCooldownThreshold() Threshold {
	if o == nil || IsNil(o.CooldownThreshold) {
		var ret Threshold
		return ret
	}
	return *o.CooldownThreshold
}

// GetCooldownThresholdOk returns a tuple with the CooldownThreshold field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetCooldownThresholdOk() (*Threshold, bool) {
	if o == nil || IsNil(o.CooldownThreshold) {
		return nil, false
	}
	return o.CooldownThreshold, true
}

// HasCooldownThreshold returns a boolean if a field has been set.
func (o *OrganizationMutable) HasCooldownThreshold() bool {
	if o != nil && !IsNil(o.CooldownThreshold) {
		return true
	}

	return false
}

// SetCooldownThreshold gets a reference to the given Threshold and assigns it to the CooldownThreshold field.
func (o *OrganizationMutable) SetCooldownThreshold(v Threshold) {
	o.CooldownThreshold = &v
}

// GetAutoresponderCooldown returns the AutoresponderCooldown field value
func (o *OrganizationMutable) GetAutoresponderCooldown() Threshold {
	if o == nil {
		var ret Threshold
		return ret
	}

	return o.AutoresponderCooldown
}

// GetAutoresponderCooldownOk returns a tuple with the AutoresponderCooldown field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetAutoresponderCooldownOk() (*Threshold, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AutoresponderCooldown, true
}

// SetAutoresponderCooldown sets field value
func (o *OrganizationMutable) SetAutoresponderCooldown(v Threshold) {
	o.AutoresponderCooldown = v
}

// GetCouponProviders returns the CouponProviders field value if set, zero value otherwise.
func (o *OrganizationMutable) GetCouponProviders() []CouponProvider {
	if o == nil || IsNil(o.CouponProviders) {
		var ret []CouponProvider
		return ret
	}
	return o.CouponProviders
}

// GetCouponProvidersOk returns a tuple with the CouponProviders field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetCouponProvidersOk() ([]CouponProvider, bool) {
	if o == nil || IsNil(o.CouponProviders) {
		return nil, false
	}
	return o.CouponProviders, true
}

// HasCouponProviders returns a boolean if a field has been set.
func (o *OrganizationMutable) HasCouponProviders() bool {
	if o != nil && !IsNil(o.CouponProviders) {
		return true
	}

	return false
}

// SetCouponProviders gets a reference to the given []CouponProvider and assigns it to the CouponProviders field.
func (o *OrganizationMutable) SetCouponProviders(v []CouponProvider) {
	o.CouponProviders = v
}

// GetExternalIntegrations returns the ExternalIntegrations field value if set, zero value otherwise.
func (o *OrganizationMutable) GetExternalIntegrations() ExternalIntegrations {
	if o == nil || IsNil(o.ExternalIntegrations) {
		var ret ExternalIntegrations
		return ret
	}
	return *o.ExternalIntegrations
}

// GetExternalIntegrationsOk returns a tuple with the ExternalIntegrations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetExternalIntegrationsOk() (*ExternalIntegrations, bool) {
	if o == nil || IsNil(o.ExternalIntegrations) {
		return nil, false
	}
	return o.ExternalIntegrations, true
}

// HasExternalIntegrations returns a boolean if a field has been set.
func (o *OrganizationMutable) HasExternalIntegrations() bool {
	if o != nil && !IsNil(o.ExternalIntegrations) {
		return true
	}

	return false
}

// SetExternalIntegrations gets a reference to the given ExternalIntegrations and assigns it to the ExternalIntegrations field.
func (o *OrganizationMutable) SetExternalIntegrations(v ExternalIntegrations) {
	o.ExternalIntegrations = &v
}

// GetLifecycleSettings returns the LifecycleSettings field value if set, zero value otherwise.
func (o *OrganizationMutable) GetLifecycleSettings() OrganizationMutableLifecycleSettings {
	if o == nil || IsNil(o.LifecycleSettings) {
		var ret OrganizationMutableLifecycleSettings
		return ret
	}
	return *o.LifecycleSettings
}

// GetLifecycleSettingsOk returns a tuple with the LifecycleSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetLifecycleSettingsOk() (*OrganizationMutableLifecycleSettings, bool) {
	if o == nil || IsNil(o.LifecycleSettings) {
		return nil, false
	}
	return o.LifecycleSettings, true
}

// HasLifecycleSettings returns a boolean if a field has been set.
func (o *OrganizationMutable) HasLifecycleSettings() bool {
	if o != nil && !IsNil(o.LifecycleSettings) {
		return true
	}

	return false
}

// SetLifecycleSettings gets a reference to the given OrganizationMutableLifecycleSettings and assigns it to the LifecycleSettings field.
func (o *OrganizationMutable) SetLifecycleSettings(v OrganizationMutableLifecycleSettings) {
	o.LifecycleSettings = &v
}

// GetContactAttributes returns the ContactAttributes field value if set, zero value otherwise.
func (o *OrganizationMutable) GetContactAttributes() []ContactAttribute {
	if o == nil || IsNil(o.ContactAttributes) {
		var ret []ContactAttribute
		return ret
	}
	return o.ContactAttributes
}

// GetContactAttributesOk returns a tuple with the ContactAttributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetContactAttributesOk() ([]ContactAttribute, bool) {
	if o == nil || IsNil(o.ContactAttributes) {
		return nil, false
	}
	return o.ContactAttributes, true
}

// HasContactAttributes returns a boolean if a field has been set.
func (o *OrganizationMutable) HasContactAttributes() bool {
	if o != nil && !IsNil(o.ContactAttributes) {
		return true
	}

	return false
}

// SetContactAttributes gets a reference to the given []ContactAttribute and assigns it to the ContactAttributes field.
func (o *OrganizationMutable) SetContactAttributes(v []ContactAttribute) {
	o.ContactAttributes = v
}

// GetDateFormat returns the DateFormat field value if set, zero value otherwise.
func (o *OrganizationMutable) GetDateFormat() string {
	if o == nil || IsNil(o.DateFormat) {
		var ret string
		return ret
	}
	return *o.DateFormat
}

// GetDateFormatOk returns a tuple with the DateFormat field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetDateFormatOk() (*string, bool) {
	if o == nil || IsNil(o.DateFormat) {
		return nil, false
	}
	return o.DateFormat, true
}

// HasDateFormat returns a boolean if a field has been set.
func (o *OrganizationMutable) HasDateFormat() bool {
	if o != nil && !IsNil(o.DateFormat) {
		return true
	}

	return false
}

// SetDateFormat gets a reference to the given string and assigns it to the DateFormat field.
func (o *OrganizationMutable) SetDateFormat(v string) {
	o.DateFormat = &v
}

// GetStopKeywords returns the StopKeywords field value
func (o *OrganizationMutable) GetStopKeywords() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.StopKeywords
}

// GetStopKeywordsOk returns a tuple with the StopKeywords field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetStopKeywordsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.StopKeywords, true
}

// SetStopKeywords sets field value
func (o *OrganizationMutable) SetStopKeywords(v []string) {
	o.StopKeywords = v
}

// GetLanguageSettings returns the LanguageSettings field value if set, zero value otherwise.
func (o *OrganizationMutable) GetLanguageSettings() OrganizationMutableLanguageSettings {
	if o == nil || IsNil(o.LanguageSettings) {
		var ret OrganizationMutableLanguageSettings
		return ret
	}
	return *o.LanguageSettings
}

// GetLanguageSettingsOk returns a tuple with the LanguageSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetLanguageSettingsOk() (*OrganizationMutableLanguageSettings, bool) {
	if o == nil || IsNil(o.LanguageSettings) {
		return nil, false
	}
	return o.LanguageSettings, true
}

// HasLanguageSettings returns a boolean if a field has been set.
func (o *OrganizationMutable) HasLanguageSettings() bool {
	if o != nil && !IsNil(o.LanguageSettings) {
		return true
	}

	return false
}

// SetLanguageSettings gets a reference to the given OrganizationMutableLanguageSettings and assigns it to the LanguageSettings field.
func (o *OrganizationMutable) SetLanguageSettings(v OrganizationMutableLanguageSettings) {
	o.LanguageSettings = &v
}

// GetFormality returns the Formality field value
func (o *OrganizationMutable) GetFormality() Formality {
	if o == nil {
		var ret Formality
		return ret
	}

	return o.Formality
}

// GetFormalityOk returns a tuple with the Formality field value
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetFormalityOk() (*Formality, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Formality, true
}

// SetFormality sets field value
func (o *OrganizationMutable) SetFormality(v Formality) {
	o.Formality = v
}

// GetValidationCenterSettings returns the ValidationCenterSettings field value if set, zero value otherwise.
func (o *OrganizationMutable) GetValidationCenterSettings() OrganizationMutableValidationCenterSettings {
	if o == nil || IsNil(o.ValidationCenterSettings) {
		var ret OrganizationMutableValidationCenterSettings
		return ret
	}
	return *o.ValidationCenterSettings
}

// GetValidationCenterSettingsOk returns a tuple with the ValidationCenterSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetValidationCenterSettingsOk() (*OrganizationMutableValidationCenterSettings, bool) {
	if o == nil || IsNil(o.ValidationCenterSettings) {
		return nil, false
	}
	return o.ValidationCenterSettings, true
}

// HasValidationCenterSettings returns a boolean if a field has been set.
func (o *OrganizationMutable) HasValidationCenterSettings() bool {
	if o != nil && !IsNil(o.ValidationCenterSettings) {
		return true
	}

	return false
}

// SetValidationCenterSettings gets a reference to the given OrganizationMutableValidationCenterSettings and assigns it to the ValidationCenterSettings field.
func (o *OrganizationMutable) SetValidationCenterSettings(v OrganizationMutableValidationCenterSettings) {
	o.ValidationCenterSettings = &v
}

// GetPolyprintShopId returns the PolyprintShopId field value if set, zero value otherwise.
func (o *OrganizationMutable) GetPolyprintShopId() string {
	if o == nil || IsNil(o.PolyprintShopId) {
		var ret string
		return ret
	}
	return *o.PolyprintShopId
}

// GetPolyprintShopIdOk returns a tuple with the PolyprintShopId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetPolyprintShopIdOk() (*string, bool) {
	if o == nil || IsNil(o.PolyprintShopId) {
		return nil, false
	}
	return o.PolyprintShopId, true
}

// HasPolyprintShopId returns a boolean if a field has been set.
func (o *OrganizationMutable) HasPolyprintShopId() bool {
	if o != nil && !IsNil(o.PolyprintShopId) {
		return true
	}

	return false
}

// SetPolyprintShopId gets a reference to the given string and assigns it to the PolyprintShopId field.
func (o *OrganizationMutable) SetPolyprintShopId(v string) {
	o.PolyprintShopId = &v
}

// GetPolyprintGroupId returns the PolyprintGroupId field value if set, zero value otherwise.
func (o *OrganizationMutable) GetPolyprintGroupId() string {
	if o == nil || IsNil(o.PolyprintGroupId) {
		var ret string
		return ret
	}
	return *o.PolyprintGroupId
}

// GetPolyprintGroupIdOk returns a tuple with the PolyprintGroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetPolyprintGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.PolyprintGroupId) {
		return nil, false
	}
	return o.PolyprintGroupId, true
}

// HasPolyprintGroupId returns a boolean if a field has been set.
func (o *OrganizationMutable) HasPolyprintGroupId() bool {
	if o != nil && !IsNil(o.PolyprintGroupId) {
		return true
	}

	return false
}

// SetPolyprintGroupId gets a reference to the given string and assigns it to the PolyprintGroupId field.
func (o *OrganizationMutable) SetPolyprintGroupId(v string) {
	o.PolyprintGroupId = &v
}

// GetPolyprintNfcProductId returns the PolyprintNfcProductId field value if set, zero value otherwise.
func (o *OrganizationMutable) GetPolyprintNfcProductId() string {
	if o == nil || IsNil(o.PolyprintNfcProductId) {
		var ret string
		return ret
	}
	return *o.PolyprintNfcProductId
}

// GetPolyprintNfcProductIdOk returns a tuple with the PolyprintNfcProductId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetPolyprintNfcProductIdOk() (*string, bool) {
	if o == nil || IsNil(o.PolyprintNfcProductId) {
		return nil, false
	}
	return o.PolyprintNfcProductId, true
}

// HasPolyprintNfcProductId returns a boolean if a field has been set.
func (o *OrganizationMutable) HasPolyprintNfcProductId() bool {
	if o != nil && !IsNil(o.PolyprintNfcProductId) {
		return true
	}

	return false
}

// SetPolyprintNfcProductId gets a reference to the given string and assigns it to the PolyprintNfcProductId field.
func (o *OrganizationMutable) SetPolyprintNfcProductId(v string) {
	o.PolyprintNfcProductId = &v
}

// GetDefaultWhatsappProvider returns the DefaultWhatsappProvider field value if set, zero value otherwise.
func (o *OrganizationMutable) GetDefaultWhatsappProvider() Provider {
	if o == nil || IsNil(o.DefaultWhatsappProvider) {
		var ret Provider
		return ret
	}
	return *o.DefaultWhatsappProvider
}

// GetDefaultWhatsappProviderOk returns a tuple with the DefaultWhatsappProvider field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetDefaultWhatsappProviderOk() (*Provider, bool) {
	if o == nil || IsNil(o.DefaultWhatsappProvider) {
		return nil, false
	}
	return o.DefaultWhatsappProvider, true
}

// HasDefaultWhatsappProvider returns a boolean if a field has been set.
func (o *OrganizationMutable) HasDefaultWhatsappProvider() bool {
	if o != nil && !IsNil(o.DefaultWhatsappProvider) {
		return true
	}

	return false
}

// SetDefaultWhatsappProvider gets a reference to the given Provider and assigns it to the DefaultWhatsappProvider field.
func (o *OrganizationMutable) SetDefaultWhatsappProvider(v Provider) {
	o.DefaultWhatsappProvider = &v
}

// GetBillingAccountId returns the BillingAccountId field value if set, zero value otherwise.
func (o *OrganizationMutable) GetBillingAccountId() string {
	if o == nil || IsNil(o.BillingAccountId) {
		var ret string
		return ret
	}
	return *o.BillingAccountId
}

// GetBillingAccountIdOk returns a tuple with the BillingAccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutable) GetBillingAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.BillingAccountId) {
		return nil, false
	}
	return o.BillingAccountId, true
}

// HasBillingAccountId returns a boolean if a field has been set.
func (o *OrganizationMutable) HasBillingAccountId() bool {
	if o != nil && !IsNil(o.BillingAccountId) {
		return true
	}

	return false
}

// SetBillingAccountId gets a reference to the given string and assigns it to the BillingAccountId field.
func (o *OrganizationMutable) SetBillingAccountId(v string) {
	o.BillingAccountId = &v
}

func (o OrganizationMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OrganizationMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["customer_id"] = o.CustomerId
	toSerialize["name"] = o.Name
	toSerialize["contact_info"] = o.ContactInfo
	if !IsNil(o.Active) {
		toSerialize["active"] = o.Active
	}
	if !IsNil(o.ExternalReferences) {
		toSerialize["external_references"] = o.ExternalReferences
	}
	if !IsNil(o.Timezone) {
		toSerialize["timezone"] = o.Timezone
	}
	if !IsNil(o.OfficeHours) {
		toSerialize["office_hours"] = o.OfficeHours
	}
	if !IsNil(o.InfoMessagesActive) {
		toSerialize["info_messages_active"] = o.InfoMessagesActive
	}
	if !IsNil(o.DirectCalling) {
		toSerialize["direct_calling"] = o.DirectCalling
	}
	toSerialize["activity_threshold"] = o.ActivityThreshold
	if !IsNil(o.ExternalSystems) {
		toSerialize["external_systems"] = o.ExternalSystems
	}
	if !IsNil(o.CooldownThreshold) {
		toSerialize["cooldown_threshold"] = o.CooldownThreshold
	}
	toSerialize["autoresponder_cooldown"] = o.AutoresponderCooldown
	if !IsNil(o.CouponProviders) {
		toSerialize["coupon_providers"] = o.CouponProviders
	}
	if !IsNil(o.ExternalIntegrations) {
		toSerialize["external_integrations"] = o.ExternalIntegrations
	}
	if !IsNil(o.LifecycleSettings) {
		toSerialize["lifecycle_settings"] = o.LifecycleSettings
	}
	if !IsNil(o.ContactAttributes) {
		toSerialize["contact_attributes"] = o.ContactAttributes
	}
	if !IsNil(o.DateFormat) {
		toSerialize["date_format"] = o.DateFormat
	}
	toSerialize["stop_keywords"] = o.StopKeywords
	if !IsNil(o.LanguageSettings) {
		toSerialize["language_settings"] = o.LanguageSettings
	}
	toSerialize["formality"] = o.Formality
	if !IsNil(o.ValidationCenterSettings) {
		toSerialize["validation_center_settings"] = o.ValidationCenterSettings
	}
	if !IsNil(o.PolyprintShopId) {
		toSerialize["polyprint_shop_id"] = o.PolyprintShopId
	}
	if !IsNil(o.PolyprintGroupId) {
		toSerialize["polyprint_group_id"] = o.PolyprintGroupId
	}
	if !IsNil(o.PolyprintNfcProductId) {
		toSerialize["polyprint_nfc_product_id"] = o.PolyprintNfcProductId
	}
	if !IsNil(o.DefaultWhatsappProvider) {
		toSerialize["default_whatsapp_provider"] = o.DefaultWhatsappProvider
	}
	if !IsNil(o.BillingAccountId) {
		toSerialize["billing_account_id"] = o.BillingAccountId
	}
	return toSerialize, nil
}

type NullableOrganizationMutable struct {
	value *OrganizationMutable
	isSet bool
}

func (v NullableOrganizationMutable) Get() *OrganizationMutable {
	return v.value
}

func (v *NullableOrganizationMutable) Set(val *OrganizationMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableOrganizationMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableOrganizationMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrganizationMutable(val *OrganizationMutable) *NullableOrganizationMutable {
	return &NullableOrganizationMutable{value: val, isSet: true}
}

func (v NullableOrganizationMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrganizationMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


